﻿#region Copyright Syncfusion Inc. 2001 - 2011
// Copyright Syncfusion Inc. 2001 - 2011. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Windows.Forms;
using Syncfusion.Pdf.Parsing;
using Syncfusion.Windows.Forms.PdfViewer;
using Syncfusion.Pdf.Exporting;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Interactive;
using System.Collections.Generic;
using System.Drawing;
using Syncfusion.Pdf;

namespace GettingStarted
{
    public partial class Form1 : Form
    {
        # region Constructor
        public Form1()
        {
            InitializeComponent();
        }
        # endregion

        # region Events
       
        private Dictionary<string, PdfLoadedBookmark> bookmarksDictionary;
        private PdfLoadedDocument ldoc;
        List<string> treeList = new List<string>();        
        bool istitleAdded = false;

        private void Form1_Load(object sender, EventArgs e)
        {
            ldoc = new PdfLoadedDocument("../../Data/Objective-C Succinctly.pdf");
            pdfViewerControl1.Load(ldoc);
           
            bool isBookmarkPresent=UpdateTreeView();
            if (!isBookmarkPresent)
            {
                Label label = new Label();
                label.Text = "No BookMark available in this document";
                label.Size = new System.Drawing.Size(180, 60);
                treeView1.Controls.Add(label);
                treeView1.Size = new System.Drawing.Size(200, 600);
            }
            else
            {
                treeView1.Size = new System.Drawing.Size(200, 600);
            }
        }

       
        private bool UpdateTreeView()
        {
            int count = 0;
            PdfBookmarkBase bookmarks = ldoc.Bookmarks;
            if (bookmarks != null && bookmarks.Count > 0)
                bookmarksDictionary = new Dictionary<string, PdfLoadedBookmark>();
            else
                return false;
            
            //Iterate through Pdf bookmarks and adds it in List view.

            foreach (PdfLoadedBookmark bookmark in bookmarks)
            {
                treeList.Add(count.ToString());
                AddBookMarkToView(bookmark,count);
                treeList.Clear();
                istitleAdded = false;
                count += 1;
            }
            return true;
        }
   
        public void AddBookMarkToView(PdfLoadedBookmark bookmark,int count)
        {      
            int child=0;
            if (bookmark.Count == 0)
            {
                treeView1.Nodes.Add(bookmark.Title.ToString());
                bookmarksDictionary.Add(bookmark.Title, bookmark);
            }
            else
            {
                if(!istitleAdded)
                treeView1.Nodes.Add(bookmark.Title);
                bookmarksDictionary.Add(bookmark.Title, bookmark);
                foreach (PdfLoadedBookmark value in bookmark)
                {
                    treeList.Add(child.ToString());
                    if (value.Count == 0)
                    {
                        //BookMark child items added with Parent Name

                        if(treeList.Count==5)
                           treeView1.Nodes[int.Parse(treeList[0])].Nodes[int.Parse(treeList[1])].Nodes[int.Parse(treeList[2])].Nodes[int.Parse(treeList[3])].Nodes.Add(value.Title);
                        else if (treeList.Count == 4)
                            treeView1.Nodes[int.Parse(treeList[0])].Nodes[int.Parse(treeList[1])].Nodes[int.Parse(treeList[2])].Nodes.Add(value.Title);
                        else if(treeList.Count==3)
                            treeView1.Nodes[int.Parse(treeList[0])].Nodes[int.Parse(treeList[1])].Nodes.Add(value.Title);
                        else
                            treeView1.Nodes[int.Parse(treeList[0])].Nodes.Add(value.Title);
                        treeList.RemoveAt(treeList.Count - 1);
                        if(!bookmarksDictionary.ContainsKey(value.Title))
                        bookmarksDictionary.Add(value.Title, value);
                    }
                    else
                    {
                        //BookMark child items added with Parent Name

                        if (treeList.Count == 5)
                            treeView1.Nodes[int.Parse(treeList[0])].Nodes[int.Parse(treeList[1])].Nodes[int.Parse(treeList[2])].Nodes[int.Parse(treeList[3])].Nodes.Add(value.Title);
                        else if (treeList.Count == 4)
                            treeView1.Nodes[int.Parse(treeList[0])].Nodes[int.Parse(treeList[1])].Nodes[int.Parse(treeList[2])].Nodes.Add(value.Title);
                        else if (treeList.Count == 3)
                            treeView1.Nodes[int.Parse(treeList[0])].Nodes[int.Parse(treeList[1])].Nodes.Add(value.Title);
                        else
                            treeView1.Nodes[int.Parse(treeList[0])].Nodes.Add(value.Title);
                        istitleAdded = true;
                        AddBookMarkToView(value, count);                       
                    }
                    child += 1;
                }
                
            }
            treeList.RemoveAt(treeList.Count - 1);
        }

       
        # endregion

        # region Helper Methods     

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            string[] selectedNode = e.Node.ToString().Split(':');

            PdfLoadedBookmark bookmark = bookmarksDictionary[selectedNode[selectedNode.Length - 1].Trim()];
            PdfPageBase page;
            if (bookmark.Destination != null)
            {
                page = bookmark.Destination.Page;
                int pageIndex = 0;
                foreach (PdfPageBase pageBase in ldoc.Pages)
                {
                    if (pageBase == page)
                    {
                        pdfViewerControl1.GoToPageAtIndex(pageIndex + 1);
                        break;
                    }
                    pageIndex++;
                }
            }
        }
        #endregion      
        
    }
}